com.buschmais.jqassistant.plugin.java.api.model

## Interface JavaArtifactFileDescriptor

- All Superinterfaces:
    com.buschmais.jqassistant.plugin.common.api.model.ArtifactDescriptor, com.buschmais.jqassistant.plugin.common.api.model.ArtifactFileDescriptor, com.buschmais.jqassistant.core.store.api.model.Descriptor, com.buschmais.jqassistant.plugin.common.api.model.FileContainerDescriptor, com.buschmais.jqassistant.plugin.common.api.model.FileDescriptor, com.buschmais.jqassistant.plugin.common.api.model.FileNameDescriptor, com.buschmais.jqassistant.core.store.api.model.FullQualifiedNameDescriptor, JavaDescriptor, com.buschmais.jqassistant.core.store.api.model.NamedDescriptor
  All Known Subinterfaces:
    JarArchiveDescriptor, JavaClassesDirectoryDescriptor

      public interface JavaArtifactFileDescriptor
      extends JavaDescriptor, com.buschmais.jqassistant.plugin.common.api.model.ArtifactFileDescriptor

  Defines a Java artifact.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `JavaArtifactFileDescriptor.RequiresType` Defines the REQUIRES relation.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<TypeDescriptor>` | `getRequiresTypes()` Return the list of Java types required by this artifact (i.e. which are referenced from it).
    `com.buschmais.xo.api.Query.Result<TypeDescriptor>` | `resolveRequiredType(String fqn, List<? extends com.buschmais.jqassistant.plugin.common.api.model.ArtifactDescriptor> dependencies)`

    - ### Methods inherited from interface com.buschmais.jqassistant.plugin.common.api.model.ArtifactDescriptor

      `getClassifier, getDependencies, getDependents, getGroup, getName, getType, getVersion, setClassifier, setGroup, setName, setType, setVersion`

    - ### Methods inherited from interface com.buschmais.jqassistant.core.store.api.model.FullQualifiedNameDescriptor

      `getFullQualifiedName, setFullQualifiedName`

    - ### Methods inherited from interface com.buschmais.jqassistant.plugin.common.api.model.FileContainerDescriptor

      `getContains`

    - ### Methods inherited from interface com.buschmais.jqassistant.plugin.common.api.model.FileNameDescriptor

      `getFileName, setFileName`

- - ### Method Detail

    - #### resolveRequiredType

          @Cypher(value="match (type:Type)<-[:CONTAINS]-(a:Artifact) where type.fqn={fqn} and id(a) in {dependencies} return type")
          com.buschmais.xo.api.Query.Result<TypeDescriptor> resolveRequiredType(String fqn,
                                                                                                                                                                                                           List<? extends com.buschmais.jqassistant.plugin.common.api.model.ArtifactDescriptor> dependencies)

    - #### getRequiresTypes

          List<TypeDescriptor> getRequiresTypes()

      Return the list of Java types required by this artifact (i.e. which are referenced from it).
      Returns:
        The list of required java types.

Copyright © 2015 buschmais GbR. All rights reserved.